local bottomLeftBackdrop = {
	bgFile = "Interface\\AddOns\\Elfosdatatext\\media\\bottomleft",
	tile = false
}

local blackBox = {
	bgFile = "Interface\\AddOns\\Elfosdatatext\\media\\blackbox",
	tile = false
}


-- BOTTOM LEFT START
-- FRAME
local bottomLeft = CreateFrame("FRAME", nil, UIParent)
bottomLeft:SetPoint("BOTTOMLEFT",UIParent,-109,-2)
bottomLeft:SetWidth(512)
bottomLeft:SetHeight(32)
bottomLeft:SetBackdrop(bottomLeftBackdrop)

-- GOLD
-- FRAME
local goldFrame = CreateFrame("FRAME", nil, bottomLeft)
goldFrame:SetPoint("CENTER", bottomLeft, -8, 2)
goldFrame:SetWidth(89)
goldFrame:SetHeight(29)
goldFrame:SetBackdrop(blackBox)

-- TEXT
local goldText = goldFrame:CreateFontString(nil, "OVERLAY")
goldText:SetPoint("CENTER",0,0)
goldText:SetSize(89,29)
goldText:SetFont("Interface\\AddOns\\Elfosdatatext\\font\\Accidental_Presidency.TTF", 14)
goldText:SetTextColor(1,1,1,1)

goldFrame:RegisterEvent("PLAYER_MONEY")
goldFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
goldFrame:RegisterEvent("TRADE_CLOSED")
goldFrame:SetScript("OnEvent", function()
	local money = GetMoney()
	local gold = floor(abs(money / 10000))
	local silver = floor(abs(mod(money / 100, 100)))
	local copper = floor(abs(mod(money, 100)))
	if gold > 1 then
		goldText:SetText(gold .."g")
	elseif silver > 1 then
		goldText:SetText(silver .."s")
	elseif copper > 1 then
		goldText:SetText(copper .."c")
	end
end)

-- ORDER RESOURCES
-- FRAME
local orFrame = CreateFrame("Button", nil, bottomLeft)
orFrame:SetPoint("CENTER", bottomLeft, 55, 2)
orFrame:SetWidth(88)
orFrame:SetHeight(29)
orFrame:SetBackdrop(blackBox)

-- TEXT
local orText = orFrame:CreateFontString(nil, "OVERLAY")
orText:SetPoint("CENTER", orFrame,0,0)
orText:SetSize(88,29)
orText:SetFont("Interface\\AddOns\\Elfosdatatext\\font\\Accidental_Presidency.TTF", 14)
orText:SetTextColor(1,1,1,1)

orFrame:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
orFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
orFrame:RegisterEvent("PLAYER_LEVEL_UP")
orFrame:RegisterEvent("BAG_UPDATE")
orFrame:SetScript("OnEvent", function()
	local playerLevel = UnitLevel("player")
	local suffix = ""
	if playerLevel > 89 then
		if playerLevel < 101 then
			local _,amount,_,_,_,_,_,_ = GetCurrencyInfo(824)
			suffix = "gr"
			orText:SetText(amount .."".. suffix)
		else
			local _,amount,_,_,_,_,_,_ = GetCurrencyInfo(1220)
			suffix = "or"
			orText:SetText(amount .."".. suffix)
		end
	else
		local backpack,_ = GetContainerNumFreeSlots(0)
		local bagone,_ = GetContainerNumFreeSlots(1)
		local bagtwo,_ = GetContainerNumFreeSlots(2)
		local bagthree,_ = GetContainerNumFreeSlots(3)
		local bagfour,_ = GetContainerNumFreeSlots(4)
		
		local slots = GetContainerNumSlots(0)
		local slotsone = GetContainerNumSlots(1)
		local slotstwo = GetContainerNumSlots(2)
		local slotsthree = GetContainerNumSlots(3)
		local slotsfour = GetContainerNumSlots(4)
		
		local usedSlots = backpack + bagone + bagtwo + bagthree + bagfour
		local totalSlots = slots + slotsone + slotstwo + slotsthree + slotsfour
		local freeSlots = totalSlots - usedSlots
		
		orText:SetText(freeSlots .."/".. totalSlots)
	end
end)

orFrame:SetScript("OnClick", function()
	local playerLevel = UnitLevel("player")
	if playerLevel > 100 then
		if ( not IsAddOnLoaded("Blizzard_GarrisonUI") ) then
			UIParentLoadAddOn("Blizzard_GarrisonUI");
		end
		if ( IsAddOnLoaded("Blizzard_GarrisonUI") ) then
			if not GarrisonLandingPage:IsShown() then
				ShowGarrisonLandingPage(LE_GARRISON_TYPE_7_0)
			else
				ToggleFrame(GarrisonLandingPage)
			end
		end
	elseif playerLevel > 89 and playerLevel < 101 then
		if ( not IsAddOnLoaded("Blizzard_GarrisonUI") ) then
			UIParentLoadAddOn("Blizzard_GarrisonUI");
		end
		if ( IsAddOnLoaded("Blizzard_GarrisonUI") ) then
			if not GarrisonLandingPage:IsShown() then
				ShowGarrisonLandingPage(LE_GARRISON_TYPE_6_0)
			else
				ToggleFrame(GarrisonLandingPage)
			end
		end
	else
		ToggleAllBags()
	end
end)



-- ITEM LEVEL
-- FRAME
local ilvlFrame = CreateFrame("FRAME", nil, bottomLeft)
ilvlFrame:SetPoint("CENTER", bottomLeft, -72, 2)
ilvlFrame:SetWidth(88)
ilvlFrame:SetHeight(29)
ilvlFrame:SetBackdrop(blackBox)

-- TEXT
ilvlText = ilvlFrame:CreateFontString(nil, "OVERLAY")
ilvlText:SetPoint("CENTER", ilvlFrame,0,0)
ilvlText:SetSize(88,29)
ilvlText:SetFont("Interface\\AddOns\\Elfosdatatext\\font\\Accidental_Presidency.TTF", 14)
ilvlText:SetTextColor(1,1,1,1)

ilvlFrame:RegisterEvent("PLAYER_AVG_ITEM_LEVEL_UPDATE")
ilvlFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
ilvlFrame:SetScript("OnEvent", function()
	local total, equipped, _ = GetAverageItemLevel()
	if total ~= equipped then
		local suffix = "/"
		ilvlText:SetFormattedText("%0.0f%s%0.0f", equipped, suffix, total)
	else
		ilvlText:SetFormattedText("iL: %0.0f", equipped)
	end
end)

-- BOTTOMLEFT END