local bottomRightBackdrop = {
	bgFile = "Interface\\AddOns\\Elfosdatatext\\media\\bottomright",
	tile = false
}

local blackBox = {
	bgFile = "Interface\\AddOns\\Elfosdatatext\\media\\blackbox",
	tile = false
}

-- BOTTOMRIGHT
  
-- BOTTOMRIGHT FRAME
local bottomRight = CreateFrame("FRAME", nil, UIParent)
bottomRight:SetPoint("BOTTOMRIGHT",UIParent,109,-2)
bottomRight:SetWidth(512)
bottomRight:SetHeight(32)
bottomRight:SetBackdrop(bottomRightBackdrop)
-- BOTTOMRIGHT FRAME END

-- DUNGEONDIFFICULTY
-- FRAME
local dungeonDifficulty = CreateFrame("Button", nil, bottomRight)
dungeonDifficulty:SetPoint("CENTER", bottomRight, 73, 2)
dungeonDifficulty:SetWidth(88)
dungeonDifficulty:SetHeight(29)
dungeonDifficulty:SetBackdrop(blackBox)
-- TEXT
local dungeonDifficultyText = dungeonDifficulty:CreateFontString(nil, "OVERLAY")
dungeonDifficultyText:SetPoint("CENTER",0,0)
dungeonDifficultyText:SetSize(88,29)
dungeonDifficultyText:SetFont("Interface\\AddOns\\Elfosdatatext\\font\\Accidental_Presidency.TTF", 14)
dungeonDifficultyText:SetTextColor(1,1,1,1)

dungeonDifficulty:RegisterEvent("PLAYER_ENTERING_WORLD")
dungeonDifficulty:RegisterEvent("ZONE_CHANGED_NEW_AREA")
dungeonDifficulty:RegisterEvent("WORLD_MAP_UPDATE")
dungeonDifficulty:RegisterEvent("ZONE_CHANGED")
dungeonDifficulty:RegisterEvent("PLAYER_ENTERING_BATTLEGROUND")
dungeonDifficulty:SetScript("OnEvent", function()
	local _,type,_,difficultyName,_,_,_,_,_ = GetInstanceInfo()
	if type == "none" then
		dungeonDifficultyText:SetText("World")
	else
		dungeonDifficultyText:SetText(difficultyName)
	end
end)

dungeonDifficulty:SetScript("OnClick", function()

	ToggleFrame(WorldMapFrame)

end)
-- DUNGEONDIFFICULTY END

-- CLOCK
-- FRAME
local clock = CreateFrame("Button", nil, bottomRight)
clock:SetPoint("CENTER", bottomRight, 10, 2)
clock:SetWidth(89)
clock:SetHeight(29)
clock:SetBackdrop(blackBox)

--TEXT
local clockText = clock:CreateFontString(nil, "OVERLAY")
clockText:SetPoint("CENTER",0,0)
clockText:SetSize(89,29)
clockText:SetFont("Interface\\AddOns\\Elfosdatatext\\font\\Accidental_Presidency.TTF", 14)
clockText:SetTextColor(1,1,1,1)

clock:SetScript("OnUpdate", function()
	local clockTime = date("%I:%M")
	clockText:SetText(clockTime)
end)

clock:SetScript("OnClick", function()
	if ( not IsAddOnLoaded("Blizzard_Calendar") ) then
         UIParentLoadAddOn("Blizzard_Calendar");
	end
	if ( Calendar_Toggle ) then
		Calendar_Toggle();
	end
end)

-- CLOCK END

-- DURABILITY
-- FRAME
local durability = CreateFrame("Button", nil, bottomRight)
durability:SetPoint("CENTER", bottomRight, -54, 2)
durability:SetWidth(88)
durability:SetHeight(29)
durability:SetBackdrop(blackBox)

-- TEXT
local duraText = durability:CreateFontString(nil, "OVERLAY")
duraText:SetPoint("CENTER",0,0)
duraText:SetSize(88,29)
duraText:SetFont("Interface\\AddOns\\Elfosdatatext\\font\\Accidental_Presidency.TTF", 14)
duraText:SetTextColor(1,1,1,1)

durability:RegisterEvent("UNIT_INVENTORY_CHANGED")
durability:RegisterEvent("PLAYER_REGEN_ENABLED")
durability:RegisterEvent("PLAYER_DEAD")
durability:RegisterEvent("PLAYER_ENTERING_WORLD")
durability:RegisterEvent("MERCHANT_UPDATE")
durability:RegisterEvent("MERCHANT_CLOSED")
durability:RegisterEvent("PLAYER_MONEY")
durability:SetScript("OnEvent", function()
	for i = 1,18 do
		local cur,max=GetInventoryItemDurability(i);
		if cur == nil or cur == "" then
			local curnil = cur
		elseif max == nil or max == "" then
			local curnil = max
		else
		    local dura = cur * 100 / max
			local suffix = "%"
			duraText:SetFormattedText("%0.0f%s", dura, suffix)
		end
	end
end)

durability:SetScript("OnClick", function()
	ToggleFrame(CharacterFrame)
end)

-- BOTTOMRIGHT END
