local topLeftBackdrop = {
	bgFile = "Interface\\AddOns\\Elfosdatatext\\media\\topleft",
	tile = false
}

local topLeftBackdropAlt = {
	bgFile = "Interface\\AddOns\\Elfosdatatext\\media\\topleft_noartifact",
	tile = false
}

local blackBox = {
	bgFile = "Interface\\AddOns\\Elfosdatatext\\media\\blackbox",
	tile = false
}

-- TOPLEFT START
-- FRAME
local topLeft = CreateFrame("FRAME", nil, UIParent)
topLeft:SetPoint("TOPLEFT", UIParent, 0,0)
topLeft:SetWidth(512)
topLeft:SetHeight(32)
topLeft:SetFrameStrata("MEDIUM")
topLeft:SetFrameLevel(1)

-- EXP BAR START
local expbar = CreateFrame("Statusbar", nil, topLeft)
expbar:SetWidth(185)
expbar:SetStatusBarTexture("Interface\\AddOns\\Elfosdatatext\\statusbar\\Flat")
expbar:GetStatusBarTexture():SetHorizTile(false)
expbar:GetStatusBarTexture():SetVertTile(false)
expbar:SetOrientation("HORIZONTAL")

expbarValue = expbar:CreateFontString(nil, "OVERLAY")
expbarValue:SetPoint("CENTER", expbar, "CENTER", 0, 0)
expbarValue:SetFont("Interface\\AddOns\\Elfosdatatext\\font\\Accidental_Presidency.TTF", 14)
expbarValue:SetJustifyH("CENTER")
expbarValue:SetTextColor(1,1,1)
expbarValue:Hide()

expbar:RegisterEvent("PLAYER_XP_UPDATE")
expbar:RegisterEvent("PLAYER_LEVEL_UP")
expbar:RegisterEvent("PLAYER_ENTERING_WORLD")
expbar:RegisterEvent("UNIT_INVENTORY_CHANGED")


-- ARTIFACT BAR START
local artbar = CreateFrame("Statusbar", nil, topLeft)
artbar:SetWidth(185)
artbar:SetStatusBarTexture("Interface\\AddOns\\Elfosdatatext\\statusbar\\Flat")
artbar:GetStatusBarTexture():SetHorizTile(false)
artbar:GetStatusBarTexture():SetVertTile(false)
artbar:SetOrientation("HORIZONTAL")
artbar:Hide()

artbarValue = artbar:CreateFontString(nil, "OVERLAY")
artbarValue:SetPoint("CENTER", artbar, "CENTER", 0, 0)
artbarValue:SetFont("Interface\\AddOns\\Elfosdatatext\\font\\Accidental_Presidency.TTF", 14)
artbarValue:SetJustifyH("CENTER")
artbarValue:SetTextColor(1,1,1)
artbarValue:Hide()

artbar:RegisterEvent("PLAYER_LEVEL_UP")
artbar:RegisterEvent("PLAYER_ENTERING_WORLD")
artbar:RegisterEvent("ARTIFACT_XP_UPDATE")
artbar:RegisterEvent("UNIT_INVENTORY_CHANGED")
artbar:RegisterEvent("UPDATE_FACTION")

-- ARTIFACT BUTTON
local artButton = CreateFrame("Button", nil, topLeft)
artButton:SetWidth(15)
artButton:SetHeight(15)
artButton:SetPoint("LEFT", topLeft, 23, -2)
artButton:SetFrameStrata("MEDIUM")
artButton:SetFrameLevel(4)
artButton:CreateTexture("artTexture")
artTexture:SetAllPoints()
artTexture:SetTexCoord(0.1, 0.9, 0.1, 0.9)
artButton:SetText("A")
artButton:Hide()

expbar:SetScript("OnEvent", function()

	local playerLevel = UnitLevel("player")
	local maxPlayerLevel = GetMaxPlayerLevel()
	
	-- EXPERIENCE BAR 
	if playerLevel ~= maxPlayerLevel then
	
		expbar:SetStatusBarColor(0,0.45,0)
					
		local curExp = UnitXP("player")
		local maxExp = UnitXPMax("player")
		local exp = curExp/maxExp*100
					
		expbar:SetMinMaxValues(0, maxExp)
		expbar:SetValue(curExp)
					
		expbarValue:SetFormattedText("%0.1f%%", exp)
	
		if playerLevel >= 100 and playerLevel < maxPlayerLevel or playerLevel < 100 then
		
			if HasArtifactEquipped() then
				
				expbar:SetHeight(6)
				expbar:SetPoint("CENTER", topLeft, "CENTER", -117, 3)
				
			end
			
			if not HasArtifactEquipped() then
				
				expbar:SetHeight(15)
				expbar:SetPoint("CENTER", topLeft, "CENTER", -117, -2)
			
			end
			
		end
		
	end
	
	if playerLevel == maxPlayerLevel then
		expbar:Hide()
	end
	
end)

artbar:SetScript("OnEvent", function()

	local playerLevel = UnitLevel("player")
	local maxPlayerLevel = GetMaxPlayerLevel()
	
	local repname, standing, repMin, repMax, repValue = GetWatchedFactionInfo()
	
	if HasArtifactEquipped() then
	
		
		topLeft:SetBackdrop(topLeftBackdrop)
		
		
		artbar:Show()
		artButton:Show()
			
		artbar:SetStatusBarColor(0.4,0,0.8)
	
		local itemID, altItemID, name, icon, totalXP, pointsSpent = C_ArtifactUI.GetEquippedArtifactInfo()
		local numPoints, artifactXP, xpForNextPoint = MainMenuBar_GetNumArtifactTraitsPurchasableFromXP(pointsSpent, totalXP)
				
		local apPerc = artifactXP/xpForNextPoint*100
				
		artTexture:SetTexture(icon)		-- TEST
		
		
		artbar:SetMinMaxValues(0,xpForNextPoint)
		artbar:SetValue(artifactXP)
		artbarValue:SetFormattedText("%d%% | +%d", apPerc, numPoints)
	
		if playerLevel < maxPlayerLevel then
			
			artbar:SetPoint("CENTER", topLeft, "CENTER", -117, -6)
			artbar:SetHeight(6)
		
		end
	
		if playerLevel == maxPlayerLevel and repname == nil then
				
			artbar:SetPoint("CENTER", topLeft, "CENTER", -117, -2)
			artbar:SetHeight(15)
			
		end
		
		if playerLevel == maxPlayerLevel and repname ~= nil then
		
			artbar:SetPoint("CENTER", topLeft, "CENTER", -117, -6)
			artbar:SetHeight(6)
			
		end
		
	end
	
	if not HasArtifactEquipped() then 
	
		artbar:Hide()
		artButton:Hide()
		topLeft:SetBackdrop(topLeftBackdropAlt)
		
	end
	
end)


expbar:SetScript("OnEnter", function()
	expbarValue:Show()
	
	
	local curExp = UnitXP("player")
	local maxExp = UnitXPMax("player")
	local remaining = maxExp - curExp
	local restedExp = GetXPExhaustion()
	
	
	local suffix = "k"
	local divider = "/"
	
	if curExp > 1000 then
		curExp = curExp/1000
		curExp = string.format("%0.1f%s", curExp, suffix)
	end
	
	if maxExp > 1000 then
		maxExpShort = maxExp/1000
		maxExpString = string.format("%0.1f%s", maxExpShort, suffix)
	end
	
	if remaining > 1000 then
		remaining = remaining/1000
		remaining = string.format("%0.1f%s", remaining, suffix)
	end
	
	if restedExp ~= nil then 

		local restedPerc = restedExp/maxExp*100
		restedPerc = string.format("(%0.0f%%)", restedPerc)
		
		if restedExp > 1000 then
			restedExp = restedExp/1000
			restedExp = string.format("%0.1f%s", restedExp, suffix)
		end
		
		rested = restedExp .." ".. restedPerc
	end
	
	GameTooltip:SetOwner(topLeft, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOPLEFT", self, "TOPLEFT", 235, -20)
	GameTooltip:ClearLines()
	
	GameTooltip:AddLine("Experience")
	GameTooltip:AddDoubleLine("Player Exp:", string.format("%s%s%s", curExp, divider, maxExpString), 1,1,1, 1,1,1)
	GameTooltip:AddDoubleLine("Exp to Level:", remaining, 1,1,1, 1,1,1)
	if restedExp ~= nil then
		GameTooltip:AddDoubleLine("Rested:", rested, 1,1,1, 1,1,1)
	end
	
	GameTooltip:Show()
	
end)
expbar:SetScript("OnLeave", function()
	expbarValue:Hide()
	
	GameTooltip:Hide()
end)


artbar:SetScript("OnEnter", function()
	artbarValue:Show()
	
	local itemID, altItemID, name, icon, totalXP, pointsSpent = C_ArtifactUI.GetEquippedArtifactInfo()
	local numPoints, artifactXP, xpForNextPoint = MainMenuBar_GetNumArtifactTraitsPurchasableFromXP(pointsSpent, totalXP)
				
	local apPerc = artifactXP/xpForNextPoint*100
	
	local suffix = "k"
	local divider = "/"
	
	if xpForNextPoint > 1000 then
		xpForNextPoint = xpForNextPoint/1000
		xpForNextPoint = string.format("%0.1f%s", xpForNextPoint, suffix)
	end
	
	if artifactXP > 1000 then
		artifactXP = artifactXP/1000
		artifactXP = string.format("%0.1f%s", artifactXP, suffix)
	end
	
	GameTooltip:SetOwner(topLeft, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOPLEFT", self, "TOPLEFT", 235, -20)
	GameTooltip:ClearLines()
	
	GameTooltip:AddLine("Artifact Power")
	GameTooltip:AddDoubleLine("Artifact Power:", string.format("%s%s%s", artifactXP, divider, xpForNextPoint), 1,1,1, 1,1,1)
	GameTooltip:AddDoubleLine("Points to Spend:", numPoints, 1,1,1, 1,1,1)
	
	GameTooltip:Show()
	
end)
artbar:SetScript("OnLeave", function()
	artbarValue:Hide()
	
	GameTooltip:Hide()
end)


-- REPUTATION BAR

local repbar = CreateFrame("Statusbar", nil, topLeft)
repbar:SetWidth(185)
repbar:SetStatusBarTexture("Interface\\AddOns\\Elfosdatatext\\statusbar\\Flat")
repbar:GetStatusBarTexture():SetHorizTile(false)
repbar:GetStatusBarTexture():SetVertTile(false)
repbar:SetOrientation("HORIZONTAL")
repbar:SetStatusBarColor(0.5,1,0.5)
repbar:Hide()

repbarValue = repbar:CreateFontString(nil, "OVERLAY")
repbarValue:SetPoint("CENTER", repbar, "CENTER", 0, 0)
repbarValue:SetFont("Interface\\AddOns\\Elfosdatatext\\font\\Accidental_Presidency.TTF", 14)
repbarValue:SetJustifyH("CENTER")
repbarValue:SetTextColor(1,1,1)
repbarValue:Hide()

repbar:RegisterEvent("PLAYER_XP_UPDATE")
repbar:RegisterEvent("PLAYER_LEVEL_UP")
repbar:RegisterEvent("PLAYER_ENTERING_WORLD")
repbar:RegisterEvent("UNIT_INVENTORY_CHANGED")
repbar:RegisterEvent("UPDATE_FACTION")

repbar:SetScript("OnEvent", function()
	local playerLevel = UnitLevel("player")
	local maxLevel = GetMaxPlayerLevel()
	local name, standing, repMin, repMax, repValue = GetWatchedFactionInfo()
	
	if name ~= nil then
		if playerLevel == maxLevel then
			if HasArtifactEquipped() then
				repbar:SetPoint("CENTER", topLeft, "CENTER", -117, 3)
				repbar:SetHeight(6)
				repbar:Show()
			else
				repbar:SetPoint("CENTER", topLeft, "CENTER", -117, -2)
				repbar:SetHeight(15)
				repbar:Show()
			end
		end
	else
		repbar:Hide()
	end
	
	if standing == 4 then
	
		repbar:SetValue(repValue)
		repbarValue:SetText(repValue .."/".. 3000)
		repbar:SetMinMaxValues(0, 3000)
		
	elseif standing == 5 then
	
		repValue = repValue - 3000
		repbar:SetValue(repValue)
		repbarValue:SetText(repValue .."/".. 6000)
		repbar:SetMinMaxValues(0, 6000)
		
	elseif standing == 6 then
	
		repValue = repValue - 9000
		repbar:SetValue(repValue)
		repbarValue:SetText(repValue .."/".. 12000)
		repbar:SetMinMaxValues(0, 12000)
		
	elseif standing == 7 then
		
		repValue = repValue - 21000
		repbar:SetValue(repValue)
		repbarValue:SetText(repValue .."/".. 21000)
		repbar:SetMinMaxValues(0, 21000)
	
	end
	
	
end)

repbar:SetScript("OnEnter", function()
	repbarValue:Show()
	
	local name, standing, repMin, repMax, repValue = GetWatchedFactionInfo()
	if standing == 4 then
		standing = "Neutral"
	elseif standing == 5 then
		standing = "Friendly"
	elseif standing == 6 then
		standing = "Honored"
	elseif standing == 7 then
		standing = "Revered"
	end
	
	GameTooltip:SetOwner(topLeft, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOPLEFT", self, "TOPLEFT", 235, -20)
	GameTooltip:ClearLines()
	
	GameTooltip:AddLine("Reputation")
	GameTooltip:AddDoubleLine("Standing:", standing, 1,1,1, 1,1,1)
	
	GameTooltip:Show()
end)

repbar:SetScript("OnLeave", function()
	repbarValue:Hide()
	GameTooltip:Hide()
end)


artButton:SetScript("OnClick", function()
	if ArtifactFrame and ArtifactFrame:IsVisible() then 
		HideUIPanel(ArtifactFrame) 
	else 
		SocketInventoryItem(16)
	end
end)